; INTRO.ASM

 B_CALL grbufclr

 ; show title

 ld hl,splashScreenImage
 ld de,plotsscreen
 ld bc,768
 ldir

 ; show a train (moving???)
  ld d,8
  ld e,56
  ld a,13
  call drawDomino
    ld d,16
  ld e,56
  ld a,14
  call drawDomino

 B_CALL grbufcpy
 B_CALL getkey


 ; remove "Tahitian Train by HM" text

 ; wipe 1

 ld hl,plotsscreen
 ld b,8
removeSplashText1:
 push bc
  push hl
  pop de
  inc de
  ld (hl),0
  ld bc,8
  ldir
   call introDelayFrame
   call introDelayFrame
 pop bc
 ld de,16
 add hl,de
 djnz removeSplashText1

 ; wipe 2

 ld hl,plotsscreen+12
 ld b,8
removeSplashText1b:
 push bc
  push hl
  pop de
  inc de
  ld (hl),0
  ld bc,8
  ldir
   call introDelayFrame
	   call introDelayFrame
 pop bc
 ld de,16
 add hl,de
 djnz removeSplashText1b

 ld hl,plotsscreen+195
 ld b,26
removeSplashText2:
 push bc
  push hl
  pop de
  inc de
  ld (hl),0
  ld bc,5
  ldir
 pop bc
 ld de,7
 add hl,de
 djnz removeSplashText2

 ; shift down

 ld b,16
splashScrollAnim:
 push bc
 ld hl,plotsscreen+755
 ld de,plotsscreen+767
 ld bc,756
 lddr
 ld hl,plotsscreen+10
 ld (hl),0
 call introDelayFrame
 pop bc
 djnz splashScrollAnim

  ; enter INTRO selector
 xor a
 ld (cursor),a
introSelector:
 ; show settings text and HIGHLIGHT selection

 ; game name
 ld hl,66
 ld (pencol),hl
 ld hl,introText4
 call vputsApp

 ld hl,256*6+76
 ld (pencol),hl
 ld hl,introText5
 call vputsApp

 ; settings menu
 set textInverse, (iy+textflags) ; sets inverse.
 ld hl,0
 ld (pencol),hl
 ld hl,introText0
 call vputsApp
 res textInverse, (iy+textflags) ; sets inverse.

 ld hl,plotsscreen+72
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),255

 ld a,(cursor)
 cp 1
 jr z,showIntroPlayers

 call eraseIntroMiddle
 jr showIntroCursor

showIntroPlayers:
 ld hl,256*16+36
 ld (pencol),hl
 ld hl,playerName1
 call vputsApp
 ld hl,256*22+42
 ld (pencol),hl
 ld hl,playerText0
 call vputsApp

 ld hl,256*30+36
 ld (pencol),hl
 ld hl,playerName2
 call vputsApp
 ld hl,256*36+42
 ld (pencol),hl
 ld hl,playerText0
 call vputsApp

 ld hl,256*44+36
 ld (pencol),hl
 ld hl,playerName3
 call vputsApp
 ld hl,256*50+42
 ld (pencol),hl
 ld hl,playerText0
 call vputsApp

showIntroCursor:
 ld a,(cursor)
 or a
 jr nz,introSelect0

 set textInverse, (iy+textflags) ; sets inverse.
introSelect0:
 ld hl,256*9+3
 ld (pencol),hl
 ld hl,introText1
 call vputsApp

 res textInverse, (iy+textflags) ; sets inverse.
 ld a,(cursor)
 cp 1
 jr nz,introSelect1

 set textInverse, (iy+textflags) ; sets inverse.
introSelect1:
 ld hl,256*17+3
 ld (pencol),hl
 ld hl,introText2
 call vputsApp

 res textInverse, (iy+textflags) ; sets inverse.
 ld a,(cursor)
 cp 2
 jr nz,introSelect2

 set textInverse, (iy+textflags) ; sets inverse.
introSelect2:
 ld hl,256*25+3
 ld (pencol),hl
 ld hl,introText3
 call vputsApp
 res textInverse, (iy+textflags) ; sets inverse.

 B_CALL grbufcpy

 ; read keypresses
 B_CALL getkey
 cp kEnter
 jr z,introEnter
 cp kUp
 jr z,introUp
 cp kDown
 jr z,introDown
 cp kMode
 jp nz,introSelector
 
 jp quitNOW

introEnter:
 ld a,(cursor)
 or a
 jp z,firstRound
 cp 2
 jp z,startHelp		; <help.asm>

 jp introSelector

introUp:
 ld a,(cursor)
 or a
 jp z,introSelector

 dec a
 ld (cursor),a
 jp introSelector

introDown:
 ld a,(cursor)
 cp 2
 jp z,introSelector
 
 inc a
 ld (cursor),a
 jp introSelector

introDelayFrame:
 push hl
  ei
  halt
  halt
  B_CALL grbufcpy
 pop hl
 ret

eraseIntroMiddle:
 ; erase intro players
 ld hl,plotsscreen+123
 ld b,50
removeIntroText:
 push bc
  push hl
  pop de
  inc de
  ld (hl),0
  ld bc,5
  ldir
 pop bc
 ld de,7
 add hl,de
 djnz removeIntroText
 ret

