; Tahitian Train
;  by Harper Maddox
; made in Tahiti
; based on a domino game called Mexican Train  
; began: 05/22/03
; playable version (game logic works): 7/16/03
; completed: 
;---------------------

 include "ti83plus.inc"

; development schedule
 include "design.txt"
 include "oldbugs.txt"

; ---
; equates
;------


 ; initialize

diDown		.equ 254 
diLeft		.equ 253 
diRight		.equ 251 
diUp		.equ 247 
diY		.equ 239
diGraph .equ 254
di2nd		.equ 223
diMode		.equ 191
diDel		.equ 127

;----
; Variables
;------------
; etc

randseed .equ appBackUpScreen	; 2
bonecursor .equ randseed+2
cursor .equ bonecursor+1
scroll .equ cursor+1				; 5
maxBone .equ scroll+1
maxScroll .equ maxBone+1
piecesLeft .equ maxScroll+1
counter .equ piecesLeft+1
double .equ counter+1
curPlayer .equ double+1
player .equ curPlayer+2			; 13
imCounter .equ player+1
cover .equ imCounter+1
vm .equ cover+1
round .equ vm+1
score1 .equ round+1
score2 .equ score1+1
score3 .equ score2+1
tempTrack .equ score3+1				; 26

centerpiece .equ tempTrack+5
boneTable .equ centerpiece+5	; 40

bones1 .equ boneTable+12
bones2 .equ bones1+64
bones3 .equ bones2+64			; 192 total

track0 .equ bones3+64
track1 .equ track0+2			; 514 total	
track2 .equ track1+128			
track3 .equ track2+128			
track4 .equ track3+128	

;------------------------
;--      HEADER        --
;------------------------

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

;This is the application header definition area required for all apps.
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h    ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h        ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h        ;Build = 1
 db 080h,048h    ;Field: App Name
 db "Train",0,0,0 ;Name = "Hello   " must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h          ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
 db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 
;End of header data

;------------------------
;-- START PROGRAM CODE --
;------------------------

prog_start:
 ; initialization
 set textwrite,(iy+sGrFlags)    ; _vputs writes directly to graph
 set appTextSave,(iy+appFlags)

 include "intro.asm"

firstRound:
 xor a
 ld (round),a
 ld (score1),a
 ld (score2),a
 ld (score3),a
 jp startRound

roundLoop:
 ld b,3
roundPointsLoop:
 push bc
  dec b
  sla b
  sla b
  sla b
  sla b
  sla b
  sla b ; x64
  ld e,b
  ld d,0
  ld hl,bones1
  add hl,de
  call countPoints
 pop bc
 ld e,b
 ld d,0
 ld hl,round
 add hl,de
 ld c,(hl)
 ld a,(cursor)
 add a,c
 ld (hl),a
 djnz roundPointsLoop

 ld a,(round)
 inc a
 cp 12
 jr z,endOfMatch
 ld (round),a
 jp startRound

endOfMatch:
 ; EVENTUALLY tell them "its over"
 jp quitNOW

quit:
 call shadeBackground

 ld hl,quitMessage0
 call showMessage

 ld a,1
 ld (imCounter),a

quitLoop:
 ; clear small area for "YES / NO"
 ld hl,plotsscreen+482
 ld b,9
clearQuitLoop:
 ld (hl),10000000b
 inc hl
 push bc
 push hl
 pop de
 inc de
 ld (hl),0
 ld bc,6
 ldir

 ld (hl),1
 inc hl
 inc hl
 inc hl
 inc hl
 inc hl
 pop bc
 djnz clearQuitLoop

 ld (hl),255
 push hl
 pop de
 inc de
 ld bc,7
 ldir

 ld a,(imCounter)
 or a
 jr z,quitLoopYES

 ld hl,256*41+32
 ld (pencol),hl
 ld hl,quitMessage1
 call vputsApp

 set textInverse, (iy+textflags) ; sets inverse.
 ld hl,256*41+56
 ld (pencol),hl
 ld hl,quitMessage2
 call vputsApp
 res textInverse, (iy+textflags) ; sets inverse.
 jr quitLoopKEYS

quitLoopYES:
 set textInverse, (iy+textflags) ; sets inverse.
 ld hl,256*41+32
 ld (pencol),hl
 ld hl,quitMessage1
 call vputsApp
 res textInverse, (iy+textflags) ; sets inverse.

 ld hl,256*41+56
 ld (pencol),hl
 ld hl,quitMessage2
 call vputsApp

 quitLoopKEYS:
 B_CALL grbufcpy
 B_CALL getkey
 cp kLeft
 jr z,quitDPAD
 cp kRight
 jr z,quitDPAD
 cp kEnter
 jr z,quitENTER

 jr quitLoop

quitDPAD:
 ld a,(imCounter)
 xor 1b
 ld (imCounter),a
 jr quitLoop

quitENTER:
 ld a,(imCounter)
 or a
 jr z,quitNOW

 jr controlLoop

quitNOW:
 ; exit code
    b_call  LCD_DRIVERON
    set     onRunning,(iy+onFlags)
    ei

    b_jump  JForceCmdNoChar

 ; UTILITY ROUTINES used by all progs
 include "round.asm"
 include "track.asm"
 include "moves.asm"
 include "bones.asm"
 include "selector.asm"
 include "winner.asm"
 include "animation.asm"
 include "message.asm"
 include "utility.asm"
 include "help.asm"
 include "sprites.asm"
 include "data.asm"

quitMessage0: db 0,"Quit Game?",0
quitMessage1: db "Yes",0
quitMessage2: db "No",0

winMessage0: db "YOU WIN!",0

playerText0: db "HUMAN",0
playerName1: db "Player 1",0
playerName2: db "Player 2",0
playerName3: db "Player 3",0

introText0: db "Settings:",0
introText1: db " play NOW",0
introText2: db " players",0
introText3: db " help",0
introText4: db "Tahitian",0
introText5: db " Train",0

scoreText0: db "round ",0
scoreText1: db " scores",0

.end
END






