; utility.asm
;  created 10/11/02

waitUntilKEYup:
 ei
 halt

 ld a,0ffh 			;resets the keypad.
 out (1),a			;'Required syntax' :)
 ld a,0bfh 			;Enable group 1.
 out (1),a 			
 in a,(1) 			;'Required Syntax'

 cp 255
 jr nz,waitUntilKEYup
 ret

delay:
 push bc
 ld b,10
 ei
delayLOP:
 halt
 djnz delayLOP
 pop bc
 ret

h_times_10_plus_l:
 push de
 push bc
 ld b,h
 ld de,10
 ld h,0
h_times_loop:
 add hl,de
 djnz h_times_loop
 pop bc
 pop de
 ret

mainScreenMessage0: db "Player ",0

showBottomRow:
 ; 768-84 = 684
 ld de,plotsscreen+684
 ld hl,bottomRow
 ld bc,84
 ldir

 ld hl,50*256+66
 ld (pencol),hl
 ld hl,mainScreenMessage0
 call vputsApp
 ld a,(player)
 inc a
 jr valueForA

shadeBackground:
 ld hl,plotsscreen
 ld c,3
shadeBGloopOuter:
 ld b,0
shadeBGloop:
 ld a,(hl)
 or 10101010b
 ld (hl),a
 inc hl
 djnz shadeBGloop
 dec c
 jr nz,shadeBGloop
 ret

valueAtHL4:
 ld a,(hl)
 and 1111b
 jr valueForA

valueAtHL:
 ld a,(hl)
valueForA:
 push hl
 ld l,a
 ld h,0
 B_CALL setxxxxop2
 B_CALL op2toop1 
 ld a,3
 B_CALL dispop1a
 pop hl
 ret


;in: a
showBits:
 bit 7,a
 call dispBit
 bit 6,a
 call dispBit
 bit 5,a
 call dispBit
 bit 4,a
 call dispBit
 bit 3,a
 call dispBit
 bit 2,a
 call dispBit
 bit 1,a
 call dispBit
 bit 0,a

dispBit:
 jr nz,disp1bit

 push af
  ld a,L0
  jr dispAbit

disp1bit:
 push af
  ld a,L1

dispAbit:
  B_CALL VPutMap
 pop af
 ret

;routine: check bit b
;purpose: check the b'th bit in a
;in: a,b
;out: z flag updated
;regs destroyed: hl
checkBitB:
 ld hl,checkBit0
 push af
 push bc
 push de
  ld a,b
  add a,a
  add a,b		; 3 bytes per (bit a,X / ret) combo
  ld e,a
  ld d,0
  add hl,de
  pop de
 pop bc
 pop af
 jp (hl)

checkBit0:
 bit 7,a
 ret
checkBit1:
 bit 6,a
 ret
checkBit2:
 bit 5,a
 ret
checkBit3:
 bit 4,a
 ret
checkBit4:
 bit 3,a
 ret
checkBit5:
 bit 2,a
 ret
checkBit6:
 bit 1,a
 ret
checkBit7:
 bit 0,a
 ret

divBy10:
 ld b,0
 or a
 ret z
div10:
 cp 10
 ret c
 sub 10
 inc b
 jr div10

putsApp:
 ld a,(hl)
 inc hl
 or a
 ret z
 B_CALL PutC
 jr putsApp

vDispText:
 ld (pencol),de
 
vputsApp:
 ld a,(hl)
 inc hl
 or a
 ret z
 push hl
 B_CALL VPutMap
 pop hl
 jr vputsApp

showHL:
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
showHLnow:
 B_CALL setxxxxop2
 B_CALL op2toop1 
 ld a,5
 B_CALL dispop1a
 ret

getrand91:
 call getrand
 and 01111111b
 cp 91
 jr nc,getrand91
 ret

getrand:
	 push hl
	 push bc
    push de
     ld hl,(randseed)
     ld   a,l
     ld   e,h
     add  a,h
     ld   h,a
     adc  a,e
     sub  h
     
     ld   de,4476
     add  hl,de
     adc  a,0
     
     ex   de,hl
     ld   l,d
     ld   h,a
     xor  a
     
     add  hl,hl
     adc  a,a
     add  hl,hl
     adc  a,a
     add  hl,hl
     adc  a,a
     
     ld   l,a
     ld   a,h
     add  a,e
     ld   e,a
     ld   a,l
     adc  a,d
     and  01Fh
     
     ld   l,e
     ld   h,a
     ld   (randseed),hl
	  ld a,e
     pop  de
	  pop bc
	  pop hl
     ret

invertScreen:
 ld hl,plotsscreen
 ld c,3
invertScreenOuter:
 ld b,0
invertScreenInner:
  ld a,(hl)
  xor 11111111b
  ld (hl),a
  inc hl
  djnz invertScreenInner

  dec c
  jr nz,invertScreenOuter
  ret


; d=x
; e=y
; a=domino num
drawDomino:
 ld hl,dominoSprites

 and 1111b

 or a
 jr z,skipDomLoop

 ld b,a 
 push de
 ld de,8
drawDomLoop:
 add hl,de
 djnz drawDomLoop

 pop de
skipDomLoop:
 ld a,d
; 8x8
; a=x
; e=y
sprite8xor:
 push hl		; store Sprite Pointer
 ld d,0
 ld hl,0
 add hl,de
 add hl,de
 add hl,de
 add hl,hl
 add hl,hl		; de * 12
 
 push af
 srl a
 srl a
 srl a			; x/8
 ld e,a
 add hl,de
 ex de,hl
 ld hl,plotsscreen	; 8e29h on 83
 add hl,de		; hl = location we want to paint at
 pop af
 
 and 111b
 or a
 jr z,aligned_sprite2

 pop ix
 ld e,a

 ld c,8			; loop 'c' times, for vertical sprite size
spriteNAloop2:

 ld b,e			; 'e' - the remainder of a, determines the offset
 ld d,(ix+0)
 xor a
shlop2:
 srl d			; right piece
 rr a			; left piece
 djnz shlop2

 push af
 ld a,(hl)
 or d
 ld (hl),a		; load the two pieces of the sprite
 inc hl
 ld b,(hl)
 pop af
 or b
 ld (hl),a

 push de		; go to next line
  ld de,11
  add hl,de
 pop de

 inc ix

 dec c
 jr nz,spriteNAloop2

 ret 
aligned_sprite2:	; hl - pointer to buffer
 pop de			; de - pointer to sprite

 ld b,8			; loops = vertical size of sprite
alop2:
 ld a,(de)
 or (hl)
 ld (hl),a

 push de
  ld de,12
  add hl,de
 pop de
 inc de
 djnz alop2
 ret
